// --------------------------------------------------------------------
// FileDialogɂAt@C擾NX
// --------------------------------------------------------------------

#ifndef _FILE_DLG_H_
#define _FILE_DLG_H_

#define FDLG_OPEN TRUE
#define FDLG_SAVE FALSE

void shortFilename(char *org,char *dst,int mxlen) ;
void pureFilename(char *pathname,char *fname) ;
void splitFname(char *purename,char *name,char *ext) ;
// --------------------------------------------------------------------
// ̃NXɃZbgꍇAfilteŕA'|'p[eBV
// gĉB
// --------------------------------------------------------------------

class FFSET{
	private:
	  char CName[32] ;
	  char Filter[512] ;
	  char DefExt[32] ;
	  void Check(void) ;
	public:
	  FFSET(char *Cnm,char *FltTmp,char *Dex){
	    strncpy(CName,Cnm,30) ;
	    strncpy(Filter,FltTmp,510) ;
	    strncpy(DefExt,Dex,30) ;
	    Check() ;
	  } ;
	  FFSET(){
	    strcpy(CName,"DEFAULT") ;
	    strcpy(Filter,"All Files|*.*|") ;
	    DefExt[0]='\0' ;
	  } ;
	  ~FFSET(){} ;
	  BOOL IsYourID(char *IDName){
	    if(CName[0]=='\0') return(FALSE) ;
	    return(!strcmp(IDName,CName)) ;
	  } ;
	  LPCTSTR FFilter(void){ return((LPCTSTR)Filter) ; } ;
	  char *DefaultExt(void){ return(DefExt) ; }
} ;

class FileDlg{
	private:
	  OPENFILENAME ofn ;
	  char Filename[256] ;
	  char SFilename[256] ;
	  char DefFname[64] ;
	  char DefExt[64] ;
	  char FileTitle[64] ;
	  char DefDir[256] ;
	  HWND owner ;
	  FFSET *FsPreset[32] ;
	  int FsPresetNumb ;
	  void Init(HWND ownerHwnd) ;
	  void setup(char *title,LPCTSTR ffilter,int save=0) ;
	public:
	  FileDlg(HWND ownerHwnd){ Init(ownerHwnd) ; } ;
	  FileDlg(){ Init(HWND_DESKTOP) ; } ;
	  ~FileDlg() ;
	  void setDefault(char *Defex,char *Defdr){
	    strcpy(DefExt,Defex) ;
	    strcpy(DefDir,Defdr) ;
	  } ;
	  void setDir(char *Defdr){ strcpy(DefDir,Defdr) ; } ;
	  void setExt(char *Defex){ strcpy(DefExt,Defex) ; } ;
	  char *GetFname(void){ return(Filename) ; } ;
	  char *GetPurename(void){ // ́AʏGetFileTitleƓlɂȂ锤
	    if(Filename[0]=='\0') return(NULL) ;
	    else return(&Filename[ofn.nFileOffset]) ;
	  } ;
	  char *GetExtension(void){
	    if(Filename[0]=='\0') return(NULL) ;
	    else return(&Filename[ofn.nFileExtension]) ;
	  } ;
	  void GetNameLabel(char *getbf){
	    if(Filename[0]=='\0') getbf[0]='\0' ;
	    strcpy(getbf,GetPurename()) ;
	    getbf[ofn.nFileExtension-ofn.nFileOffset-1]='\0' ;
	  } ;
	  char *GetShortname(int maxlen=21) ;
	  void GetShortname(char *getbf,int maxlen=21) ;
	  char *GetFileTitle(void){ return(FileTitle) ; } ;
	  BOOL OpenDlg(char *title,LPCTSTR ffilter) ;
	  BOOL SaveDlg(char *title,LPCTSTR ffilter) ;
	  BOOL OpenDlg(char *title,LPCTSTR ffilter,char *GetFname) ;
	  BOOL SaveDlg(char *title,LPCTSTR ffilter,char *GetFname) ;
	  BOOL OpenDlg(char *title,LPCTSTR ffilter,char *defext,char *GetFname){
	    setExt(defext) ;
	    return(OpenDlg(title,ffilter,GetFname)) ;
	  } ;
	  BOOL SaveDlg(char *title,LPCTSTR ffilter,char *defext,char *GetFname){
	    setExt(defext) ;
	    return(SaveDlg(title,ffilter,GetFname)) ;
	  } ;
	  void UseDefaultFname(char *deffile) ;
	  BOOL Preset(char *FFID,char *ffilter,char *defext) ;
	  BOOL Select(char *title,char *getfn,char *FFID,BOOL fd_Open_or_Save) ;
} ;

#endif
